diff --git a/src/gui/kernel/qwindowsysteminterface.cpp b/src/gui/kernel/qwindowsysteminterface.cpp
index 7da812f64d..e048bd6691 100644
--- a/src/gui/kernel/qwindowsysteminterface.cpp
+++ b/src/gui/kernel/qwindowsysteminterface.cpp
@@ -626,7 +626,7 @@ bool QWindowSystemInterface::handleWheelEvent(QWindow *window, ulong timestamp,
 */
 void QWindowSystemInterface::registerInputDevice(const QInputDevice *device)
 {
-    qCDebug(lcQpaInputDevices) << "register" << device;
+    qDebug() << "register" << device;
     QInputDevicePrivate::registerDevice(device);
 }
 
@@ -912,6 +912,7 @@ bool QWindowSystemInterface::handleTabletEvent(QWindow *window, ulong timestamp,
                                                qreal tangentialPressure, qreal rotation, int z,
                                                Qt::KeyboardModifiers modifiers)
 {
+    qDebug() << __FUNCTION__ << '1';
     QWindowSystemInterfacePrivate::TabletEvent *e =
         new QWindowSystemInterfacePrivate::TabletEvent(window, timestamp,
                                                        QHighDpi::fromNativeLocalPosition(local, window),
@@ -926,6 +927,7 @@ bool QWindowSystemInterface::handleTabletEvent(QWindow *window, ulong timestamp,
                                                qreal tangentialPressure, qreal rotation, int z, qint64 uid,
                                                Qt::KeyboardModifiers modifiers)
 {
+    qDebug() << __FUNCTION__ << '2';
     const QPointingDevice *dev = QPointingDevicePrivate::tabletDevice(QInputDevice::DeviceType(device),QPointingDevice::PointerType(pointerType),
                                                                       QPointingDeviceUniqueId::fromNumericId(uid));
     return handleTabletEvent(window, timestamp, dev, local, global, buttons, pressure,
@@ -937,6 +939,7 @@ bool QWindowSystemInterface::handleTabletEvent(QWindow *window, const QPointF &l
                                                qreal tangentialPressure, qreal rotation, int z, qint64 uid,
                                                Qt::KeyboardModifiers modifiers)
 {
+    qDebug() << __FUNCTION__ << '3';
     ulong time = QWindowSystemInterfacePrivate::eventTime.elapsed();
     return handleTabletEvent(window, time, local, global, device, pointerType, buttons, pressure,
                       xTilt, yTilt, tangentialPressure, rotation, z, uid, modifiers);
@@ -948,6 +951,7 @@ bool QWindowSystemInterface::handleTabletEnterLeaveProximityEvent(QWindow *windo
                                                                   qreal tangentialPressure, qreal rotation, int z,
                                                                   Qt::KeyboardModifiers modifiers)
 {
+    qDebug() << __FUNCTION__ << '1';
     Q_UNUSED(window);
     Q_UNUSED(local);
     Q_UNUSED(global);
@@ -971,6 +975,7 @@ bool QWindowSystemInterface::handleTabletEnterLeaveProximityEvent(QWindow *windo
 
 bool QWindowSystemInterface::handleTabletEnterProximityEvent(ulong timestamp, int deviceType, int pointerType, qint64 uid)
 {
+    qDebug() << __FUNCTION__ << '2';
     const QPointingDevice *device = QPointingDevicePrivate::tabletDevice(QInputDevice::DeviceType(deviceType),
                                                                          QPointingDevice::PointerType(pointerType),
                                                                          QPointingDeviceUniqueId::fromNumericId(uid));
@@ -981,12 +986,14 @@ bool QWindowSystemInterface::handleTabletEnterProximityEvent(ulong timestamp, in
 
 void QWindowSystemInterface::handleTabletEnterProximityEvent(int deviceType, int pointerType, qint64 uid)
 {
+    qDebug() << __FUNCTION__ << '3';
     ulong time = QWindowSystemInterfacePrivate::eventTime.elapsed();
     handleTabletEnterProximityEvent(time, deviceType, pointerType, uid);
 }
 
 bool QWindowSystemInterface::handleTabletLeaveProximityEvent(ulong timestamp, int deviceType, int pointerType, qint64 uid)
 {
+    qDebug() << __FUNCTION__ << '1';
     const QPointingDevice *device = QPointingDevicePrivate::tabletDevice(QInputDevice::DeviceType(deviceType),
                                                                          QPointingDevice::PointerType(pointerType),
                                                                          QPointingDeviceUniqueId::fromNumericId(uid));
@@ -997,6 +1004,7 @@ bool QWindowSystemInterface::handleTabletLeaveProximityEvent(ulong timestamp, in
 
 void QWindowSystemInterface::handleTabletLeaveProximityEvent(int deviceType, int pointerType, qint64 uid)
 {
+    qDebug() << __FUNCTION__ << '2';
     ulong time = QWindowSystemInterfacePrivate::eventTime.elapsed();
     handleTabletLeaveProximityEvent(time, deviceType, pointerType, uid);
 }
diff --git a/tests/manual/qtabletevent/regular_widgets/regular_widgets.pro b/tests/manual/qtabletevent/regular_widgets/regular_widgets.pro
index 1428d10a04..f8734107cd 100644
--- a/tests/manual/qtabletevent/regular_widgets/regular_widgets.pro
+++ b/tests/manual/qtabletevent/regular_widgets/regular_widgets.pro
@@ -1,4 +1,4 @@
 TEMPLATE = app
 QT += widgets gui-private core-private
-
+CONFIG += console
 SOURCES += main.cpp